<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN" [

<!ENTITY % output.html      "IGNORE">
<!ENTITY % output.print     "IGNORE">
<!ENTITY % output.print.tex "IGNORE">
<!ENTITY % output.print.rtf "IGNORE">

<![ %output.html; [
<!ENTITY docbook.dsl PUBLIC "-//Norman Walsh//DOCUMENT DocBook HTML Stylesheet//EN" CDATA DSSSL>
]]>
<![ %output.print; [
<!ENTITY docbook.dsl PUBLIC "-//Norman Walsh//DOCUMENT DocBook Print Stylesheet//EN" CDATA DSSSL>
]]>
]>

<!-- $NetBSD$ -->

<style-sheet>
  <style-specification use="docbook">
    <style-specification-body>

      (element username ($mono-seq$))
      (element groupname ($mono-seq$))
      (element devicename ($mono-seq$))
      (element maketarget ($mono-seq$))
      (element makevar ($mono-seq$))

      <!-- We would like the author attributions to show up in line
           with the section they refer to.  Authors who made the same
           contribution should be listed in a single <authorgroup> and 
           only one of the <author> elements should contain a <contrib>
           element that describes what the whole authorgroup was
           responsible for.  For example:

           <chapterinfo>
             <authorgroup>
               <author>
                 <firstname>Bob</firstname>
                 <surname>Jones</surname>
                 <contrib>Contributed by </contrib>
               </author>
               <author>
                 <firstname>Sarah</firstname>
                 <surname>Lee</surname>
               </author>
             </authorgroup>
           </chapterinfo>

           Would show up as "Contributed by Bob Jones and Sarah Lee".  Each
           authorgroup shows up as a separate sentence. -->

     (element chapterinfo 
        (process-children))
      (element sect1info 
        (process-children))
      (element sect2info 
        (process-children))
      (element sect3info 
        (process-children))
      (element sect4info 
        (process-children))
      (element sect5info 
        (process-children))
      (element (chapterinfo authorgroup author)
        (literal (author-list-string)))
      (element (sect1info authorgroup author)
        (literal (author-list-string)))
      (element (sect2info authorgroup author)
        (literal (author-list-string)))
      (element (sect3info authorgroup author)
        (literal (author-list-string)))
      (element (sect4info authorgroup author)
        (literal (author-list-string)))
      (element (sect5info authorgroup author)
        (literal (author-list-string)))

      (define (custom-authorgroup)
        ($italic-seq$
          (make sequence
            (process-node-list (select-elements (descendants (current-node))
                                  (normalize "contrib")))
            (process-children)
            (literal ".  "))))

      (element (chapterinfo authorgroup)
        (custom-authorgroup))
      (element (sect1info authorgroup)
        (custom-authorgroup))
      (element (sect2info authorgroup)
        (custom-authorgroup))
      (element (sect3info authorgroup)
        (custom-authorgroup))
      (element (sect4info authorgroup)
        (custom-authorgroup))
      (element (sect5info authorgroup)
        (custom-authorgroup))

      <![ %output.html; [

      ;; $Id: myhtml.dsl,v 1.1.1.1 2000/12/11 10:10:24 dent Exp $
      ;;
      ;; This file is part of the Modular DocBook Stylesheet distribution.
      ;; See ../README or http://www.berkshire.net/~norm/dsssl/
      ;;
      ;; Example of a customization layer on top of the modular docbook style
      ;; sheet.  Definitions inserted in this file take precedence over 
      ;; definitions in the 'use'd stylesheet(s).
      
      (define %graphic-default-extension% "gif")

      (define %root-filename%
      ;; Name for the root HTML document
      "netbsd")
      
      (define %html-ext%
      ;; Default extension for HTML output files
      ".html")
      
      (define %use-id-as-filename%
      ;; Use ID attributes as name for component HTML files?
      #t)
      
      (define html-manifest
      ;; Write a manifest?
      #f)
      
      (define (chunk-element-list)
        (list (normalize "preface")
              (normalize "chapter")
              (normalize "appendix") 
              (normalize "article")
              (normalize "glossary")
              (normalize "bibliography")
              (normalize "index")
              (normalize "colophon")
              (normalize "setindex")
              (normalize "reference")
              (normalize "refentry")
              (normalize "part")
              ;;	(normalize "sect1") 
              ;;	(normalize "section") 
              (normalize "book") ;; just in case nothing else matches...
              (normalize "set")  ;; sets are definitely chunks...
              ))

      (define %chapter-autolabel% 
      ;; Are chapters enumerated?
      #t)

      (define %section-autolabel%
      ;; Are sections enumerated?
      #t)

      (define %stylesheet%
      ;; REFENTRY stylesheet
      ;; PURP Name of the stylesheet to use
      ;; DESC
      ;; The name of the stylesheet to place in the HTML LINK TAG, or '#f' to
      ;; suppress the stylesheet LINK.
      ;; /DESC
      ;; AUTHOR N/A
      ;; /REFENTRY
      "docbook.css")

      (define (article-titlepage-recto-elements)
        (list (normalize "title")
              (normalize "subtitle")
              (normalize "corpauthor")
              (normalize "authorgroup")
              (normalize "author")
              (normalize "releaseinfo")
              (normalize "copyright")
              (normalize "pubdate")
              (normalize "revhistory")
              (normalize "legalnotice")
              (normalize "abstract")))
      ]]>

      <![ %output.print; [
      <![ %output.print.tex; [
      ;; $Id: mytex.dsl,v 1.1.1.1 2000/12/11 10:10:24 dent Exp $
      ;;
      ;; This file is part of the Modular DocBook Stylesheet distribution.
      ;; See ../README or http://www.berkshire.net/~norm/dsssl/
      ;;
      ;; Example of a customization layer on top of the modular docbook style
      ;; sheet.  Definitions inserted in this file take precedence over 
      ;; definitions in the 'use'd stylesheet(s).
      
      (define %graphic-default-extension% "eps")
      
      (define %generate-book-titlepage%
      ;; Should a book title page be produced?
      #t)
      
      (define %chapter-autolabel% 
      ;; Are chapters enumerated?
      #t)
      
      (define %section-autolabel%
      ;; Are sections enumerated?
      #t)
      
      (define %figure-rules%
      ;; Specify rules before and after an Figure
      #f)
      ]]>
      
      <![ %output.print.rtf; [
      
      ;; $Id: myrtf.dsl,v 1.1.1.1 2000/12/11 10:10:24 dent Exp $
      ;;
      ;; This file is part of the Modular DocBook Stylesheet distribution.
      ;; See ../README or http://www.berkshire.net/~norm/dsssl/
      ;;
      ;; Example of a customization layer on top of the modular docbook style
      ;; sheet.  Definitions inserted in this file take precedence over 
      ;; definitions in the 'use'd stylesheet(s).
      
      (define %graphic-default-extension% "bmp")
      
      (define %generate-book-titlepage%
      ;; Should a book title page be produced?
      #t)
      
      (define %chapter-autolabel% 
      ;; Are chapters enumerated?
      #t)
      
      (define %section-autolabel%
      ;; Are sections enumerated?
      #t)
      
      (define %figure-rules%
      ;; Specify rules before and after an Figure
      #f)
      ]]>
      ]]>
  
    </style-specification-body>
  </style-specification>

  <external-specification id="docbook" document="docbook.dsl">
</style-sheet>
