# using XSLT stylesheet

SX_BIN?=	${PREFIX}/bin/sx
SX_OPTS?=	${SGML_CATALOGS} -xlower -xndata -xempty -f .sxerr
SX?=		${SX_BIN} ${SX_OPTS} ${SX_FLAGS} ${XML_DECL}

XSLTPROC_BIN?=	${PREFIX}/bin/xsltproc
XSLTPROC_HTML_OPTS?=	

XML_CATALOG_FILES?=	${PREFIX}/share/xml/catalog

XSLTPROC?=	env ${XSLTPROC_ENV} ${XSLTPROC_BIN} ${XSLTPROC_ARGS}

XSLT?=		netbsd-html.xsl
MASTER_XSLT?=	${WEB_PREFIX}/guide/share/xsl/${XSLT}
LOCAL_XSLT?=	share/${XSLT}

XSLT_CHUNK?=		netbsd-html-chunk.xsl
MASTER_CHUNK_XSLT?=	${WEB_PREFIX}/guide/share/xsl/${XSLT_CHUNK}
LOCAL_CHUNK_XSLT?=	share/${XSLT_CHUNK}

XSLTPROC_ENV+=  SGML_CATALOG_FILES=
XSLTPROC_ENV+=  XML_CATALOG_FILES=${XML_CATALOG_FILES}
XSLTPROC_ARGS+= --stringparam manifest ${MANIFEST}
#XSLTPROC_ARGS+= --stringparam LOCALBASE ${LOCALBASE}
#XSLTPROC_ARGS+= --stringparam WEB_PREFIX ${WEB_PREFIX}
.if !empty(XML_CATALOG_FILES)
XSLTPROC_ARGS+= --nonet --catalogs
.endif

master.xsl: ${MASTER_XSLT}
	${CAT} $? | ${SED} -e "s#@@DBX_XSL_HTMLCHUNK@@#${DBX_XSL_HTMLCHUNK}#;s#@@DBX_XSL_HTML@@#${DBX_XSL_HTML}#;s#@@WEB_PREFIX@@#${WEB_PREFIX}#" > $@

default.xsl: ${LOCAL_XSLT}
	${CAT} $? | ${SED} -e "s#@@DBX_XSL_HTMLCHUNK@@#${DBX_XSL_HTMLCHUNK}#;s#@@DBX_XSL_HTML@@#${DBX_XSL_HTML}#;s#@@WEB_PREFIX@@#${WEB_PREFIX}#" > $@

master-chunk.xsl: ${MASTER_CHUNK_XSLT}
	${CAT} $? | ${SED} -e "s#@@DBX_XSL_HTMLCHUNK@@#${DBX_XSL_HTMLCHUNK}#;s#@@DBX_XSL_HTML@@#${DBX_XSL_HTML}#;s#@@WEB_PREFIX@@#${WEB_PREFIX}#" > $@

default-chunk.xsl: ${LOCAL_CHUNK_XSLT}
	${CAT} $? | ${SED} -e "s#@@DBX_XSL_HTMLCHUNK@@#${DBX_XSL_HTMLCHUNK}#;s#@@DBX_XSL_HTML@@#${DBX_XSL_HTML}#;s#@@WEB_PREFIX@@#${WEB_PREFIX}#" > $@

default.xml: ${SRC}
	echo '<?xml version="1.0"?>' > $@
	echo '<!DOCTYPE book SYSTEM "${DBX_DTD}">' >> $@
	-${SX} ${DOC}.xml | tail -n +2 >> $@

${DOC}.html: master.xsl default.xml default.xsl
	${XSLTPROC} default.xsl default.xml > $@
	echo "$@" >> ${MANIFEST}
.if !defined(NO_TIDY)
	-${TIDY} `cat ${MANIFEST}` 
.endif

default-chunk.xml: ${SRC}
	echo '<?xml version="1.0"?>' > $@
	echo '<!DOCTYPE book SYSTEM "${DBX_DTD}">' >> $@
	-${SX} ${DOC}.xml  | tail -n +2 >> $@

${HTML_INDEX}: master-chunk.xsl default-chunk.xml default-chunk.xsl
	${XSLTPROC} default-chunk.xsl default-chunk.xml
.if !defined(NO_TIDY)
	-${TIDY} `cat ${MANIFEST}` 
.endif
